<?php

namespace web\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OpenstaandeVacatures_InternResponse StructType
 * @subpackage Structs
 */
class OpenstaandeVacatures_InternResponse extends AbstractStructBase
{
    /**
     * The Vacatures
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \web\StructType\Vacatures[]
     */
    public $Vacatures;
    /**
     * Constructor method for OpenstaandeVacatures_InternResponse
     * @uses OpenstaandeVacatures_InternResponse::setVacatures()
     * @param \web\StructType\Vacatures[] $vacatures
     */
    public function __construct(array $vacatures = array())
    {
        $this
            ->setVacatures($vacatures);
    }
    /**
     * Get Vacatures value
     * @return \web\StructType\Vacatures[]|null
     */
    public function getVacatures()
    {
        return $this->Vacatures;
    }
    /**
     * Set Vacatures value
     * @throws \InvalidArgumentException
     * @param \web\StructType\Vacatures[] $vacatures
     * @return \web\StructType\OpenstaandeVacatures_InternResponse
     */
    public function setVacatures(array $vacatures = array())
    {
        foreach ($vacatures as $openstaandeVacatures_InternResponseVacaturesItem) {
            // validation for constraint: itemType
            if (!$openstaandeVacatures_InternResponseVacaturesItem instanceof \web\StructType\Vacatures) {
                throw new \InvalidArgumentException(sprintf('The Vacatures property can only contain items of \web\StructType\Vacatures, "%s" given', is_object($openstaandeVacatures_InternResponseVacaturesItem) ? get_class($openstaandeVacatures_InternResponseVacaturesItem) : gettype($openstaandeVacatures_InternResponseVacaturesItem)), __LINE__);
            }
        }
        $this->Vacatures = $vacatures;
        return $this;
    }
    /**
     * Add item to Vacatures value
     * @throws \InvalidArgumentException
     * @param \web\StructType\Vacatures $item
     * @return \web\StructType\OpenstaandeVacatures_InternResponse
     */
    public function addToVacatures(\web\StructType\Vacatures $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \web\StructType\Vacatures) {
            throw new \InvalidArgumentException(sprintf('The Vacatures property can only contain items of \web\StructType\Vacatures, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Vacatures[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \web\StructType\OpenstaandeVacatures_InternResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
