<?php

namespace web\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SD_Afdeling StructType
 * @subpackage Structs
 */
class SD_Afdeling extends AbstractStructBase
{
    /**
     * The AfdelingsCode
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - maxLength: 200
     * @var string
     */
    public $AfdelingsCode;
    /**
     * The AfdelingsNaam
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - maxLength: 200
     * @var string
     */
    public $AfdelingsNaam;
    /**
     * Constructor method for SD_Afdeling
     * @uses SD_Afdeling::setAfdelingsCode()
     * @uses SD_Afdeling::setAfdelingsNaam()
     * @param string $afdelingsCode
     * @param string $afdelingsNaam
     */
    public function __construct($afdelingsCode = null, $afdelingsNaam = null)
    {
        $this
            ->setAfdelingsCode($afdelingsCode)
            ->setAfdelingsNaam($afdelingsNaam);
    }
    /**
     * Get AfdelingsCode value
     * @return string|null
     */
    public function getAfdelingsCode()
    {
        return $this->AfdelingsCode;
    }
    /**
     * Set AfdelingsCode value
     * @param string $afdelingsCode
     * @return \web\StructType\SD_Afdeling
     */
    public function setAfdelingsCode($afdelingsCode = null)
    {
        // validation for constraint: maxLength
        if ((is_scalar($afdelingsCode) && strlen($afdelingsCode) > 200) || (is_array($afdelingsCode) && count($afdelingsCode) > 200)) {
            throw new \InvalidArgumentException(sprintf('Invalid length, please provide an array with 200 element(s) or a scalar of 200 character(s) at most, "%d" length given', is_scalar($afdelingsCode) ? strlen($afdelingsCode) : count($afdelingsCode)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($afdelingsCode) && !is_string($afdelingsCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($afdelingsCode)), __LINE__);
        }
        $this->AfdelingsCode = $afdelingsCode;
        return $this;
    }
    /**
     * Get AfdelingsNaam value
     * @return string|null
     */
    public function getAfdelingsNaam()
    {
        return $this->AfdelingsNaam;
    }
    /**
     * Set AfdelingsNaam value
     * @param string $afdelingsNaam
     * @return \web\StructType\SD_Afdeling
     */
    public function setAfdelingsNaam($afdelingsNaam = null)
    {
        // validation for constraint: maxLength
        if ((is_scalar($afdelingsNaam) && strlen($afdelingsNaam) > 200) || (is_array($afdelingsNaam) && count($afdelingsNaam) > 200)) {
            throw new \InvalidArgumentException(sprintf('Invalid length, please provide an array with 200 element(s) or a scalar of 200 character(s) at most, "%d" length given', is_scalar($afdelingsNaam) ? strlen($afdelingsNaam) : count($afdelingsNaam)), __LINE__);
        }
        // validation for constraint: string
        if (!is_null($afdelingsNaam) && !is_string($afdelingsNaam)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($afdelingsNaam)), __LINE__);
        }
        $this->AfdelingsNaam = $afdelingsNaam;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \web\StructType\SD_Afdeling
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
